////////////////////////////////////////////////////////////////////////////////
//
//  ****************************************************************************
//  * Project   : Inject/Eject Library Demo
//  * Unit Name : main
//  * Purpose   :   
//  *           :   CreateRemoteThread
//  * Author    :  (Rouse_) 
//  * Version   : 1.01
//  * HomePage  : http://rouse.drkb.ru
//  ****************************************************************************
//

unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, TlHelp32;

resourcestring
  BTN_INJECT = 'Inject';
  BTN_EJECT  = 'Eject';
  
const
  DLLName = 'hooklib.dll';

type
  TfrmMain = class(TForm)
    btnInjectEject: TButton;
    GroupBox: TGroupBox;
    lbStatus: TListBox;
    cbProcess: TComboBox;
    Label1: TLabel;
    procedure btnInjectEjectClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    UnloadAddrOffset: DWORD;
    procedure FillProcessCombo;
    function InjectLib(const ProcessID: DWORD): Boolean;
    function EjectLib(const ProcessID: DWORD): Boolean;
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

{ TfrmMain }

//     / 
// =============================================================================
procedure TfrmMain.btnInjectEjectClick(Sender: TObject);
var
  PID: Integer;
begin
  PID := DWORD(cbProcess.Items.Objects[cbProcess.ItemIndex]);
  TComponent(Sender).Tag := TComponent(Sender).Tag + 1;
  if (TComponent(Sender).Tag mod 2) = 1 then
  begin
    btnInjectEject.Caption := BTN_EJECT;
    if InjectLib(PID) then
      lbStatus.Items.Add('Library injected succes.')
    else
      lbStatus.Items.Add('Library injected fail.');
  end
  else
  begin
    btnInjectEject.Caption := BTN_INJECT;
    if EjectLib(PID) then
      lbStatus.Items.Add('Library ejected succes.')
    else
      lbStatus.Items.Add('Library ejected fail.');
  end;
end;

//        ,
//       
// =============================================================================
function SetDebugPriv: Boolean;
var
  Token: THandle;
  tkp: TTokenPrivileges;
  ReturnLength: DWORD;
begin
  Result := false;
  //    
  if OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, Token) then
  try
    //  Luid 
    if LookupPrivilegeValue(nil, PChar('SeDebugPrivilege'), tkp.Privileges[0].Luid) then
    begin
      //   
      tkp.PrivilegeCount := 1;
      tkp.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
      //  
      Result := AdjustTokenPrivileges(Token, false, tkp, 0, nil, ReturnLength);
    end;
  finally
    CloseHandle(Token);
  end;
end;    

//         PID  ProcessID
//         LoadLibraryA
//      .
//           
// =============================================================================
function TfrmMain.InjectLib(const ProcessID: DWORD): Boolean;
var
  Process: HWND;
  ThreadRtn: FARPROC;
  DllPath: String;
  RemoteDll: Pointer;
  BytesWriten: DWORD;
  Thread: DWORD;
  ThreadId: DWORD;
begin
  //      
  Result := SetDebugPriv;
  if not Result then Exit;
  Process := 0;
  Thread := 0;
  try
    //  
    Process := OpenProcess(PROCESS_CREATE_THREAD or PROCESS_VM_OPERATION or
      PROCESS_VM_WRITE, True, ProcessID);
    if Process = 0 then Exit;
    //      
    DllPath := ExtractFilePath(ParamStr(0)) + DLLName;
    RemoteDll := VirtualAllocEx(Process, nil, Length(DllPath),
      MEM_COMMIT or MEM_TOP_DOWN, PAGE_READWRITE);
    if RemoteDll = nil then Exit;
    //        
    if not WriteProcessMemory(Process, RemoteDll, PChar(DllPath),
      Length(DllPath), BytesWriten) then Exit;
    if BytesWriten <> DWORD(Length(DllPath)) then Exit;
    //     Kernel32.dll
    ThreadRtn := GetProcAddress(GetModuleHandle('Kernel32.dll'), 'LoadLibraryA');
    if ThreadRtn = nil then Exit;
    //   
    Thread := CreateRemoteThread(Process, nil, 0, ThreadRtn, RemoteDll, 0, ThreadId);
    if Thread = 0 then Exit;
    //     ...
    if (WaitForSingleObject(Thread, INFINITE) = WAIT_OBJECT_0) then
      Result := True;
  finally
    //         ,
    //    ...
    if RemoteDll <> nil then
      VirtualFreeEx(Process, @RemoteDll, 0, MEM_RELEASE);
    if Thread <> 0 then CloseHandle(Thread);
    if Process <> 0 then CloseHandle(Process);  
  end;
end;

//        
//      JMP [EBX]
//   EBX     SelfUnload,
//     .
//       
//     +    
// =============================================================================
function TfrmMain.EjectLib(const ProcessID: DWORD): Boolean;
var
  hModuleSnap: THandle;
  ModuleEntry: TModuleEntry32;
  Process: HWND;
  BytesWriten: DWORD;
  Thread: DWORD;
  ThreadId: DWORD;
  ExitCode: DWORD;
  PLibHandle: PDWORD;
  OpCode: PWORD;
  CurrUnloadAddrOffset: DWORD;
begin
  Result := False;
  //   
  hModuleSnap := CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, ProcessID);
  if hModuleSnap <> INVALID_HANDLE_VALUE then
  try
    FillChar(ModuleEntry, SizeOf(TModuleEntry32), #0);
    ModuleEntry.dwSize := SizeOf(TModuleEntry32);
    if not Module32First(hModuleSnap, ModuleEntry) then Exit;
    repeat
      if AnsiUpperCase(ModuleEntry.szModule) =
        AnsiUpperCase(DLLName) then
      begin
        //   
        CurrUnloadAddrOffset := ModuleEntry.hModule + UnloadAddrOffset;
        Break;
      end;
    until not Module32Next(hModuleSnap, ModuleEntry);
  finally
    CloseHandle(hModuleSnap);
  end;


  //      
  Result := SetDebugPriv;
  if not Result then Exit;

  Process := 0;
  Thread := 0;
  try
    //  
    Process := OpenProcess(PROCESS_CREATE_THREAD or PROCESS_VM_OPERATION or
      PROCESS_VM_WRITE, True, ProcessID);
    if Process = 0 then Exit;

    //   jmp [ebx]
    OpCode := VirtualAllocEx(Process, nil, 2,
      MEM_COMMIT or MEM_TOP_DOWN, PAGE_READWRITE);
    ModuleEntry.hModule := $23FF;
    if not WriteProcessMemory(Process, OpCode, @ModuleEntry.hModule,
      2, BytesWriten) then Exit;

    //     (    EBX   )
    PLibHandle := VirtualAllocEx(Process, nil, 4,
      MEM_COMMIT or MEM_TOP_DOWN, PAGE_READWRITE);
    if not WriteProcessMemory(Process, PLibHandle, @CurrUnloadAddrOffset,
      4, BytesWriten) then Exit;

    //  
    Thread := CreateRemoteThread(Process, nil, 0, OpCode,
      PLibHandle, 0, ThreadId);

    if Thread = 0 then Exit;
    //     ...
    if (WaitForSingleObject(Thread, INFINITE) = WAIT_OBJECT_0) then
      if GetExitCodeThread(Thread, ExitCode) then
        Result := ExitCode = 0;
  finally
    //         ,
    //    ...
    if OpCode <> nil then
      VirtualFreeEx(Process, @OpCode, 0, MEM_RELEASE);
    if PLibHandle <> nil then
      VirtualFreeEx(Process, @PLibHandle, 0, MEM_RELEASE);
    if Thread <> 0 then CloseHandle(Thread);
    if Process <> 0 then CloseHandle(Process);
  end;
end;

type
  PSYSTEM_THREADS = ^SYSTEM_THREADS;
  SYSTEM_THREADS  = packed record
    KernelTime: LARGE_INTEGER;
    UserTime: LARGE_INTEGER;
    CreateTime: LARGE_INTEGER;
    WaitTime: ULONG;
    StartAddress: Pointer;
    UniqueProcess: DWORD;
    UniqueThread: DWORD;
    Priority: Integer;
    BasePriority: Integer;
    ContextSwitchCount: ULONG;
    State: Longint;
    WaitReason: Longint;
  end;

  PSYSTEM_PROCESS_INFORMATION = ^SYSTEM_PROCESS_INFORMATION;
  SYSTEM_PROCESS_INFORMATION = packed record
    NextOffset: ULONG;
    ThreadCount: ULONG;
    Reserved1: array [0..5] of ULONG;
    CreateTime: FILETIME;
    UserTime: FILETIME;
    KernelTime: FILETIME;
    ModuleNameLength: WORD;
    ModuleNameMaxLength: WORD;
    ModuleName: PWideChar;
    BasePriority: ULONG;
    ProcessID: ULONG;
    InheritedFromUniqueProcessID: ULONG;
    HandleCount: ULONG;
    Reserved2 : array[0..1] of ULONG;
    PeakVirtualSize : ULONG;
    VirtualSize : ULONG;
    PageFaultCount : ULONG;
    PeakWorkingSetSize : ULONG;
    WorkingSetSize : ULONG;
    QuotaPeakPagedPoolUsage : ULONG;
    QuotaPagedPoolUsage : ULONG;
    QuotaPeakNonPagedPoolUsage : ULONG;
    QuotaNonPagedPoolUsage : ULONG;
    PageFileUsage : ULONG;
    PeakPageFileUsage : ULONG;
    PrivatePageCount : ULONG;
    ReadOperationCount : LARGE_INTEGER;
    WriteOperationCount : LARGE_INTEGER;
    OtherOperationCount : LARGE_INTEGER;
    ReadTransferCount : LARGE_INTEGER;
    WriteTransferCount : LARGE_INTEGER;
    OtherTransferCount : LARGE_INTEGER;
    ThreadInfo: array [0..0] of SYSTEM_THREADS;
  end;

  function NtQuerySystemInformation(
    SystemInformationClass: DWORD;
    SystemInformation : Pointer;
    SystemInformationLength : DWORD;
    var ReturnLength: DWORD
    ): DWORD; stdcall; external 'ntdll.dll';

procedure TfrmMain.FillProcessCombo;
const
  SystemProcessesAndThreadsInformation = 5;
  STATUS_INFO_LENGTH_MISMATCH = $C0000004;
var
  SystemInformation, Temp: PSYSTEM_PROCESS_INFORMATION;
  ReturnLength: DWORD;
begin
  cbProcess.Items.BeginUpdate;
  try
    cbProcess.Items.Clear;
    ReturnLength := 0;
    //    
    if NtQuerySystemInformation(
      SystemProcessesAndThreadsInformation,
      nil, 0, ReturnLength) <> STATUS_INFO_LENGTH_MISMATCH then Exit;
    if ReturnLength > 0 then
    begin
      //  
      GetMem(SystemInformation, ReturnLength);
      try
        //   
        if NtQuerySystemInformation(SystemProcessesAndThreadsInformation,
          SystemInformation, ReturnLength, ReturnLength) = 0 then
        begin
          //        
          Temp := SystemInformation;
          repeat
            //        IDLE
            if (Temp^.ModuleName <> nil) and (Temp^.ProcessID <> 4) then
              cbProcess.Items.AddObject(
                Temp^.ModuleName, Pointer(Temp^.ProcessID));
            Temp := Pointer(DWORD(Temp) + Temp^.NextOffset);
          until Temp^.NextOffset = 0;
        end;
      finally
        FreeMem(SystemInformation);
      end;
    end;
  finally
    cbProcess.Items.EndUpdate;
  end;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
var
  hLibHandle: THandle;
begin
  //   
  FillProcessCombo;  
  hLibHandle := LoadLibraryEx(
    PChar(ExtractFilePath(ParamStr(0)) + DLLName), 0,
    DONT_RESOLVE_DLL_REFERENCES);
  try
    UnloadAddrOffset :=
      DWORD(GetProcAddress(hLibHandle, 'SelfUnload')) - hLibHandle;
    if UnloadAddrOffset = -hLibHandle then Exit;
  finally
    FreeLibrary(hLibHandle);
  end;
end;

end.
